# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['AppSecCustomRuleActionArgs', 'AppSecCustomRuleAction']

@pulumi.input_type
class AppSecCustomRuleActionArgs:
    def __init__(__self__, *,
                 config_id: pulumi.Input[int],
                 custom_rule_action: pulumi.Input[str],
                 custom_rule_id: pulumi.Input[int],
                 security_policy_id: pulumi.Input[str]):
        """
        The set of arguments for constructing a AppSecCustomRuleAction resource.
        :param pulumi.Input[int] config_id: . Unique identifier of the security configuration associated with the custom rule action being modified.
        :param pulumi.Input[str] custom_rule_action: . Action to be taken when the custom rule is invoked. Allowed values are:
               - **alert**. Record the event.
               - **deny**. Block the request.
               - **deny_custom_{custom_deny_id}**. Take the action specified by the custom deny.
               - **none**. Take no action.
        :param pulumi.Input[int] custom_rule_id: . Unique identifier of the custom rule whose action is being modified.
        :param pulumi.Input[str] security_policy_id: . Unique identifier of the security policy associated with the custom rule action being modified.
        """
        pulumi.set(__self__, "config_id", config_id)
        pulumi.set(__self__, "custom_rule_action", custom_rule_action)
        pulumi.set(__self__, "custom_rule_id", custom_rule_id)
        pulumi.set(__self__, "security_policy_id", security_policy_id)

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> pulumi.Input[int]:
        """
        . Unique identifier of the security configuration associated with the custom rule action being modified.
        """
        return pulumi.get(self, "config_id")

    @config_id.setter
    def config_id(self, value: pulumi.Input[int]):
        pulumi.set(self, "config_id", value)

    @property
    @pulumi.getter(name="customRuleAction")
    def custom_rule_action(self) -> pulumi.Input[str]:
        """
        . Action to be taken when the custom rule is invoked. Allowed values are:
        - **alert**. Record the event.
        - **deny**. Block the request.
        - **deny_custom_{custom_deny_id}**. Take the action specified by the custom deny.
        - **none**. Take no action.
        """
        return pulumi.get(self, "custom_rule_action")

    @custom_rule_action.setter
    def custom_rule_action(self, value: pulumi.Input[str]):
        pulumi.set(self, "custom_rule_action", value)

    @property
    @pulumi.getter(name="customRuleId")
    def custom_rule_id(self) -> pulumi.Input[int]:
        """
        . Unique identifier of the custom rule whose action is being modified.
        """
        return pulumi.get(self, "custom_rule_id")

    @custom_rule_id.setter
    def custom_rule_id(self, value: pulumi.Input[int]):
        pulumi.set(self, "custom_rule_id", value)

    @property
    @pulumi.getter(name="securityPolicyId")
    def security_policy_id(self) -> pulumi.Input[str]:
        """
        . Unique identifier of the security policy associated with the custom rule action being modified.
        """
        return pulumi.get(self, "security_policy_id")

    @security_policy_id.setter
    def security_policy_id(self, value: pulumi.Input[str]):
        pulumi.set(self, "security_policy_id", value)


@pulumi.input_type
class _AppSecCustomRuleActionState:
    def __init__(__self__, *,
                 config_id: Optional[pulumi.Input[int]] = None,
                 custom_rule_action: Optional[pulumi.Input[str]] = None,
                 custom_rule_id: Optional[pulumi.Input[int]] = None,
                 security_policy_id: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering AppSecCustomRuleAction resources.
        :param pulumi.Input[int] config_id: . Unique identifier of the security configuration associated with the custom rule action being modified.
        :param pulumi.Input[str] custom_rule_action: . Action to be taken when the custom rule is invoked. Allowed values are:
               - **alert**. Record the event.
               - **deny**. Block the request.
               - **deny_custom_{custom_deny_id}**. Take the action specified by the custom deny.
               - **none**. Take no action.
        :param pulumi.Input[int] custom_rule_id: . Unique identifier of the custom rule whose action is being modified.
        :param pulumi.Input[str] security_policy_id: . Unique identifier of the security policy associated with the custom rule action being modified.
        """
        if config_id is not None:
            pulumi.set(__self__, "config_id", config_id)
        if custom_rule_action is not None:
            pulumi.set(__self__, "custom_rule_action", custom_rule_action)
        if custom_rule_id is not None:
            pulumi.set(__self__, "custom_rule_id", custom_rule_id)
        if security_policy_id is not None:
            pulumi.set(__self__, "security_policy_id", security_policy_id)

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> Optional[pulumi.Input[int]]:
        """
        . Unique identifier of the security configuration associated with the custom rule action being modified.
        """
        return pulumi.get(self, "config_id")

    @config_id.setter
    def config_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "config_id", value)

    @property
    @pulumi.getter(name="customRuleAction")
    def custom_rule_action(self) -> Optional[pulumi.Input[str]]:
        """
        . Action to be taken when the custom rule is invoked. Allowed values are:
        - **alert**. Record the event.
        - **deny**. Block the request.
        - **deny_custom_{custom_deny_id}**. Take the action specified by the custom deny.
        - **none**. Take no action.
        """
        return pulumi.get(self, "custom_rule_action")

    @custom_rule_action.setter
    def custom_rule_action(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "custom_rule_action", value)

    @property
    @pulumi.getter(name="customRuleId")
    def custom_rule_id(self) -> Optional[pulumi.Input[int]]:
        """
        . Unique identifier of the custom rule whose action is being modified.
        """
        return pulumi.get(self, "custom_rule_id")

    @custom_rule_id.setter
    def custom_rule_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "custom_rule_id", value)

    @property
    @pulumi.getter(name="securityPolicyId")
    def security_policy_id(self) -> Optional[pulumi.Input[str]]:
        """
        . Unique identifier of the security policy associated with the custom rule action being modified.
        """
        return pulumi.get(self, "security_policy_id")

    @security_policy_id.setter
    def security_policy_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "security_policy_id", value)


class AppSecCustomRuleAction(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 config_id: Optional[pulumi.Input[int]] = None,
                 custom_rule_action: Optional[pulumi.Input[str]] = None,
                 custom_rule_id: Optional[pulumi.Input[int]] = None,
                 security_policy_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        **Scopes**: Custom rule

        Associates an action with a custom rule. Custom rules are rules that you define yourself and are not part of the Kona Rule Set.

        **Related API Endpoint**: [/appsec/v1/configs/{configId}/custom-rules](https://techdocs.akamai.com/application-security/reference/get-configs-custom-rules)

        ## Example Usage

        Basic usage:

        ```python
        import pulumi
        import pulumi_akamai as akamai

        configuration = akamai.get_app_sec_configuration(name="Documentation")
        create_custom_rule_action = akamai.AppSecCustomRuleAction("createCustomRuleAction",
            config_id=configuration.config_id,
            security_policy_id="gms1_134637",
            custom_rule_id=12345,
            custom_rule_action="alert")
        pulumi.export("customRuleId", create_custom_rule_action.custom_rule_id)
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] config_id: . Unique identifier of the security configuration associated with the custom rule action being modified.
        :param pulumi.Input[str] custom_rule_action: . Action to be taken when the custom rule is invoked. Allowed values are:
               - **alert**. Record the event.
               - **deny**. Block the request.
               - **deny_custom_{custom_deny_id}**. Take the action specified by the custom deny.
               - **none**. Take no action.
        :param pulumi.Input[int] custom_rule_id: . Unique identifier of the custom rule whose action is being modified.
        :param pulumi.Input[str] security_policy_id: . Unique identifier of the security policy associated with the custom rule action being modified.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: AppSecCustomRuleActionArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        **Scopes**: Custom rule

        Associates an action with a custom rule. Custom rules are rules that you define yourself and are not part of the Kona Rule Set.

        **Related API Endpoint**: [/appsec/v1/configs/{configId}/custom-rules](https://techdocs.akamai.com/application-security/reference/get-configs-custom-rules)

        ## Example Usage

        Basic usage:

        ```python
        import pulumi
        import pulumi_akamai as akamai

        configuration = akamai.get_app_sec_configuration(name="Documentation")
        create_custom_rule_action = akamai.AppSecCustomRuleAction("createCustomRuleAction",
            config_id=configuration.config_id,
            security_policy_id="gms1_134637",
            custom_rule_id=12345,
            custom_rule_action="alert")
        pulumi.export("customRuleId", create_custom_rule_action.custom_rule_id)
        ```

        :param str resource_name: The name of the resource.
        :param AppSecCustomRuleActionArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(AppSecCustomRuleActionArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 config_id: Optional[pulumi.Input[int]] = None,
                 custom_rule_action: Optional[pulumi.Input[str]] = None,
                 custom_rule_id: Optional[pulumi.Input[int]] = None,
                 security_policy_id: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = AppSecCustomRuleActionArgs.__new__(AppSecCustomRuleActionArgs)

            if config_id is None and not opts.urn:
                raise TypeError("Missing required property 'config_id'")
            __props__.__dict__["config_id"] = config_id
            if custom_rule_action is None and not opts.urn:
                raise TypeError("Missing required property 'custom_rule_action'")
            __props__.__dict__["custom_rule_action"] = custom_rule_action
            if custom_rule_id is None and not opts.urn:
                raise TypeError("Missing required property 'custom_rule_id'")
            __props__.__dict__["custom_rule_id"] = custom_rule_id
            if security_policy_id is None and not opts.urn:
                raise TypeError("Missing required property 'security_policy_id'")
            __props__.__dict__["security_policy_id"] = security_policy_id
        super(AppSecCustomRuleAction, __self__).__init__(
            'akamai:index/appSecCustomRuleAction:AppSecCustomRuleAction',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            config_id: Optional[pulumi.Input[int]] = None,
            custom_rule_action: Optional[pulumi.Input[str]] = None,
            custom_rule_id: Optional[pulumi.Input[int]] = None,
            security_policy_id: Optional[pulumi.Input[str]] = None) -> 'AppSecCustomRuleAction':
        """
        Get an existing AppSecCustomRuleAction resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] config_id: . Unique identifier of the security configuration associated with the custom rule action being modified.
        :param pulumi.Input[str] custom_rule_action: . Action to be taken when the custom rule is invoked. Allowed values are:
               - **alert**. Record the event.
               - **deny**. Block the request.
               - **deny_custom_{custom_deny_id}**. Take the action specified by the custom deny.
               - **none**. Take no action.
        :param pulumi.Input[int] custom_rule_id: . Unique identifier of the custom rule whose action is being modified.
        :param pulumi.Input[str] security_policy_id: . Unique identifier of the security policy associated with the custom rule action being modified.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _AppSecCustomRuleActionState.__new__(_AppSecCustomRuleActionState)

        __props__.__dict__["config_id"] = config_id
        __props__.__dict__["custom_rule_action"] = custom_rule_action
        __props__.__dict__["custom_rule_id"] = custom_rule_id
        __props__.__dict__["security_policy_id"] = security_policy_id
        return AppSecCustomRuleAction(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> pulumi.Output[int]:
        """
        . Unique identifier of the security configuration associated with the custom rule action being modified.
        """
        return pulumi.get(self, "config_id")

    @property
    @pulumi.getter(name="customRuleAction")
    def custom_rule_action(self) -> pulumi.Output[str]:
        """
        . Action to be taken when the custom rule is invoked. Allowed values are:
        - **alert**. Record the event.
        - **deny**. Block the request.
        - **deny_custom_{custom_deny_id}**. Take the action specified by the custom deny.
        - **none**. Take no action.
        """
        return pulumi.get(self, "custom_rule_action")

    @property
    @pulumi.getter(name="customRuleId")
    def custom_rule_id(self) -> pulumi.Output[int]:
        """
        . Unique identifier of the custom rule whose action is being modified.
        """
        return pulumi.get(self, "custom_rule_id")

    @property
    @pulumi.getter(name="securityPolicyId")
    def security_policy_id(self) -> pulumi.Output[str]:
        """
        . Unique identifier of the security policy associated with the custom rule action being modified.
        """
        return pulumi.get(self, "security_policy_id")

