# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['AppSecMatchTargetSequenceArgs', 'AppSecMatchTargetSequence']

@pulumi.input_type
class AppSecMatchTargetSequenceArgs:
    def __init__(__self__, *,
                 config_id: pulumi.Input[int],
                 match_target_sequence: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a AppSecMatchTargetSequence resource.
        :param pulumi.Input[int] config_id: . Unique identifier of the security configuration associated with the match target sequence being modified.
        :param pulumi.Input[str] match_target_sequence: . Path to a JSON file containing the processing sequence for all the match targets defined for the security configuration. You can find a sample match target sequence JSON file in the [Modify match target order](https://techdocs.akamai.com/application-security/reference/put-match-targets-sequence) section of the Application Security API documentation.
        """
        pulumi.set(__self__, "config_id", config_id)
        if match_target_sequence is not None:
            pulumi.set(__self__, "match_target_sequence", match_target_sequence)

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> pulumi.Input[int]:
        """
        . Unique identifier of the security configuration associated with the match target sequence being modified.
        """
        return pulumi.get(self, "config_id")

    @config_id.setter
    def config_id(self, value: pulumi.Input[int]):
        pulumi.set(self, "config_id", value)

    @property
    @pulumi.getter(name="matchTargetSequence")
    def match_target_sequence(self) -> Optional[pulumi.Input[str]]:
        """
        . Path to a JSON file containing the processing sequence for all the match targets defined for the security configuration. You can find a sample match target sequence JSON file in the [Modify match target order](https://techdocs.akamai.com/application-security/reference/put-match-targets-sequence) section of the Application Security API documentation.
        """
        return pulumi.get(self, "match_target_sequence")

    @match_target_sequence.setter
    def match_target_sequence(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "match_target_sequence", value)


@pulumi.input_type
class _AppSecMatchTargetSequenceState:
    def __init__(__self__, *,
                 config_id: Optional[pulumi.Input[int]] = None,
                 match_target_sequence: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering AppSecMatchTargetSequence resources.
        :param pulumi.Input[int] config_id: . Unique identifier of the security configuration associated with the match target sequence being modified.
        :param pulumi.Input[str] match_target_sequence: . Path to a JSON file containing the processing sequence for all the match targets defined for the security configuration. You can find a sample match target sequence JSON file in the [Modify match target order](https://techdocs.akamai.com/application-security/reference/put-match-targets-sequence) section of the Application Security API documentation.
        """
        if config_id is not None:
            pulumi.set(__self__, "config_id", config_id)
        if match_target_sequence is not None:
            pulumi.set(__self__, "match_target_sequence", match_target_sequence)

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> Optional[pulumi.Input[int]]:
        """
        . Unique identifier of the security configuration associated with the match target sequence being modified.
        """
        return pulumi.get(self, "config_id")

    @config_id.setter
    def config_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "config_id", value)

    @property
    @pulumi.getter(name="matchTargetSequence")
    def match_target_sequence(self) -> Optional[pulumi.Input[str]]:
        """
        . Path to a JSON file containing the processing sequence for all the match targets defined for the security configuration. You can find a sample match target sequence JSON file in the [Modify match target order](https://techdocs.akamai.com/application-security/reference/put-match-targets-sequence) section of the Application Security API documentation.
        """
        return pulumi.get(self, "match_target_sequence")

    @match_target_sequence.setter
    def match_target_sequence(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "match_target_sequence", value)


class AppSecMatchTargetSequence(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 config_id: Optional[pulumi.Input[int]] = None,
                 match_target_sequence: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        **Scopes**: Security configuration

        Specifies the order in which match targets are applied within a security configuration. As a general rule, you should process broader and more-general match targets first, gradually working your way down to more granular and highly-specific targets.

        **Related API Endpoint**: [/appsec/v1/configs/{configId}/versions/{versionNumber}/match-targets/sequence](https://techdocs.akamai.com/application-security/reference/put-match-targets-sequence)

        ## Example Usage

        Basic usage:

        ```python
        import pulumi
        import pulumi_akamai as akamai

        configuration = akamai.get_app_sec_configuration(name="Documentation")
        match_target_sequence = akamai.AppSecMatchTargetSequence("matchTargetSequence",
            config_id=configuration.config_id,
            match_target_sequence=(lambda path: open(path).read())(f"{path['module']}/match_targets_sequence.json"))
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] config_id: . Unique identifier of the security configuration associated with the match target sequence being modified.
        :param pulumi.Input[str] match_target_sequence: . Path to a JSON file containing the processing sequence for all the match targets defined for the security configuration. You can find a sample match target sequence JSON file in the [Modify match target order](https://techdocs.akamai.com/application-security/reference/put-match-targets-sequence) section of the Application Security API documentation.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: AppSecMatchTargetSequenceArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        **Scopes**: Security configuration

        Specifies the order in which match targets are applied within a security configuration. As a general rule, you should process broader and more-general match targets first, gradually working your way down to more granular and highly-specific targets.

        **Related API Endpoint**: [/appsec/v1/configs/{configId}/versions/{versionNumber}/match-targets/sequence](https://techdocs.akamai.com/application-security/reference/put-match-targets-sequence)

        ## Example Usage

        Basic usage:

        ```python
        import pulumi
        import pulumi_akamai as akamai

        configuration = akamai.get_app_sec_configuration(name="Documentation")
        match_target_sequence = akamai.AppSecMatchTargetSequence("matchTargetSequence",
            config_id=configuration.config_id,
            match_target_sequence=(lambda path: open(path).read())(f"{path['module']}/match_targets_sequence.json"))
        ```

        :param str resource_name: The name of the resource.
        :param AppSecMatchTargetSequenceArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(AppSecMatchTargetSequenceArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 config_id: Optional[pulumi.Input[int]] = None,
                 match_target_sequence: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = AppSecMatchTargetSequenceArgs.__new__(AppSecMatchTargetSequenceArgs)

            if config_id is None and not opts.urn:
                raise TypeError("Missing required property 'config_id'")
            __props__.__dict__["config_id"] = config_id
            __props__.__dict__["match_target_sequence"] = match_target_sequence
        super(AppSecMatchTargetSequence, __self__).__init__(
            'akamai:index/appSecMatchTargetSequence:AppSecMatchTargetSequence',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            config_id: Optional[pulumi.Input[int]] = None,
            match_target_sequence: Optional[pulumi.Input[str]] = None) -> 'AppSecMatchTargetSequence':
        """
        Get an existing AppSecMatchTargetSequence resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[int] config_id: . Unique identifier of the security configuration associated with the match target sequence being modified.
        :param pulumi.Input[str] match_target_sequence: . Path to a JSON file containing the processing sequence for all the match targets defined for the security configuration. You can find a sample match target sequence JSON file in the [Modify match target order](https://techdocs.akamai.com/application-security/reference/put-match-targets-sequence) section of the Application Security API documentation.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _AppSecMatchTargetSequenceState.__new__(_AppSecMatchTargetSequenceState)

        __props__.__dict__["config_id"] = config_id
        __props__.__dict__["match_target_sequence"] = match_target_sequence
        return AppSecMatchTargetSequence(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="configId")
    def config_id(self) -> pulumi.Output[int]:
        """
        . Unique identifier of the security configuration associated with the match target sequence being modified.
        """
        return pulumi.get(self, "config_id")

    @property
    @pulumi.getter(name="matchTargetSequence")
    def match_target_sequence(self) -> pulumi.Output[Optional[str]]:
        """
        . Path to a JSON file containing the processing sequence for all the match targets defined for the security configuration. You can find a sample match target sequence JSON file in the [Modify match target order](https://techdocs.akamai.com/application-security/reference/put-match-targets-sequence) section of the Application Security API documentation.
        """
        return pulumi.get(self, "match_target_sequence")

