# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = [
    'GetAppSecHostnameCoverageResult',
    'AwaitableGetAppSecHostnameCoverageResult',
    'get_app_sec_hostname_coverage',
]

@pulumi.output_type
class GetAppSecHostnameCoverageResult:
    """
    A collection of values returned by getAppSecHostnameCoverage.
    """
    def __init__(__self__, id=None, json=None, output_text=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if json and not isinstance(json, str):
            raise TypeError("Expected argument 'json' to be a str")
        pulumi.set(__self__, "json", json)
        if output_text and not isinstance(output_text, str):
            raise TypeError("Expected argument 'output_text' to be a str")
        pulumi.set(__self__, "output_text", output_text)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def json(self) -> str:
        return pulumi.get(self, "json")

    @property
    @pulumi.getter(name="outputText")
    def output_text(self) -> str:
        return pulumi.get(self, "output_text")


class AwaitableGetAppSecHostnameCoverageResult(GetAppSecHostnameCoverageResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetAppSecHostnameCoverageResult(
            id=self.id,
            json=self.json,
            output_text=self.output_text)


def get_app_sec_hostname_coverage(opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetAppSecHostnameCoverageResult:
    """
    **Scopes**: Individual account

    Returns information about the hostnames associated with your account. The returned data includes the hostname's protections, activation status, and other summary information.

    **Related API Endpoint**: [/appsec/v1/hostname-coverage](https://techdocs.akamai.com/application-security/reference/get-hostname-coverage)

    ## Example Usage

    Basic usage:

    ```python
    import pulumi
    import pulumi_akamai as akamai

    hostname_coverage = akamai.get_app_sec_hostname_coverage()
    pulumi.export("hostnameCoverageListJson", hostname_coverage.json)
    pulumi.export("hostnameCoverageListOutput", hostname_coverage.output_text)
    ```
    ## Output Options

    The following options can be used to determine the information returned, and how that returned information is formatted:

    - `json`. JSON-formatted list of the hostname coverage information.
    - `output_text`. Tabular report of the hostname coverage information.
    """
    __args__ = dict()
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('akamai:index/getAppSecHostnameCoverage:getAppSecHostnameCoverage', __args__, opts=opts, typ=GetAppSecHostnameCoverageResult).value

    return AwaitableGetAppSecHostnameCoverageResult(
        id=__ret__.id,
        json=__ret__.json,
        output_text=__ret__.output_text)
